//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SetUnit.h"
#include "TetrisUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSettingForm *SettingForm;

extern int kub_num;//    
extern bool only_max_fig;//      
extern int bW;// 
extern int bH;// 
extern bool GamePause;
extern bool GameOver;
extern int sp;
extern int sp_max;//  - min = 10
extern bool FlowMove;
extern float cub_H;
//---------------------------------------------------------------------------
__fastcall TSettingForm::TSettingForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSettingForm::Button2Click(TObject *Sender)
{
SettingForm->Close();
GamePause = false;
MainForm->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TSettingForm::FormPaint(TObject *Sender)
{
MassWidthUpDown->Position = bW;
MassHeightUpDown->Position = bH;
KubNumUpDown->Position = kub_num;
EqualSizeCheck->Checked = only_max_fig;
SpeedUpDown->Position = (11 - sp/(sp_max/10));
FlowMoveCheck->Checked = FlowMove;
CubSizeUpDown->Position = int(cub_H*10);
}
//---------------------------------------------------------------------------
void __fastcall TSettingForm::Button1Click(TObject *Sender)
{
bW = MassWidthUpDown->Position;
bH = MassHeightUpDown->Position;
kub_num = KubNumUpDown->Position;
sp = (11 - SpeedUpDown->Position) * (sp_max/10);
only_max_fig = EqualSizeCheck->Checked;
FlowMove = FlowMoveCheck->Checked;
cub_H = float(CubSizeUpDown->Position)/10;
SettingForm->Close();
MainForm->Visible = true;
MainForm->NewGame();
GamePause = false;
}
//---------------------------------------------------------------------------

void __fastcall TSettingForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
MainForm->Visible = true;
}
//---------------------------------------------------------------------------

