//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <gl\gl.h> 
#include <gl\glu.h>
//#include <gl\glaux.h>
#include <float.h>

#include "TetrisUnit.h"
#include "SetUnit.h"
//---------------------------------------------------------------------------
//                              _Maestro
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
float X_look,Y_look,Z_look,R_look;
GLuint m_uiTexture[1];

int kub_num = 4;//    
bool only_max_fig = true;//      
bool show_next_fig = true;
bool fig_gr[15][15]; // figure growth,        [kub_num-1][kub_num2-1]
bool real_figure[8][8]; //     

bool fig_gr_next[15][15]; // figure growth,        [kub_num-1][kub_num2-1]
//bool real_figure_next[8][8]; //     

int bW = 15;// 
int bH = 20;// 
bool basket[30][40];
//bool basket_x[30][40];
bool basket_image[30][40];//basket_image = basket real_figure
bool GamePause = false;
int X_fig, Y_fig, Y;
int sp_max = 100;//  - min = 10
int sp;//
bool new_fig = false;
bool GameOver = false;
bool NowPaint = false;
bool CubTexture = true;
bool FlowMove = true;
float cub_H = 0.8f;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{

    Application->OnIdle = &WhenIdle;
    _control87(MCW_EM, MCW_EM);

sp = sp_max;
randomize();
NewGame();

/*for(int i=0; i<bW;i++)
    for(int j=0; j<bH;j++)
         basket_x[i][j] = random(2);*/


}

//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
        SetWindowStats(800, 600, 32);

    m_hDC = GetDC(Handle);
    SetPixelFormatDescriptor();
    m_hRC = wglCreateContext(m_hDC);
    wglMakeCurrent(m_hDC, m_hRC);

    // Init the rotation variables



    // Necessary to set up before InitGL
    FormResize(NULL);
    InitGL();
}
//--------------------------------------------------------------------------- 
void __fastcall TMainForm::SetPixelFormatDescriptor()
{ 
    PIXELFORMATDESCRIPTOR pfd = {
        sizeof(PIXELFORMATDESCRIPTOR),
        1,
        PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
        PFD_TYPE_RGBA,
        24,           // Color buffer
        0,0,0,0,0,0,
        0,0,
        0,0,0,0,0,
        32,           // Depth buffer
        0,            // Stencil buffer
        0,
        PFD_MAIN_PLANE,
        0,
        0,0,0
        };
    m_iPixelFormat = ChoosePixelFormat(m_hDC, &pfd);
    SetPixelFormat(m_hDC, m_iPixelFormat, &pfd);

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormResize(TObject *Sender)
{
   wglMakeCurrent(m_hDC, m_hRC);

   glViewport(0, 0, ClientWidth, ClientHeight);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();

	 // Calculate The Aspect Ratio Of The Window
   	 gluPerspective(45.0, static_cast<double>(ClientWidth) /
                        static_cast<double>(ClientHeight),
                  0.1,100.0);

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   wglMakeCurrent(m_hDC, NULL);

}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::SetWindowStats(int iWidth_, int iHeight_, int iColor_)
{
    char str[] = " \t- \n\t\t\t- 'P'\n\t\t- 'S'\n\t \t- 'N'\n\t\t\t-  NUM LOCK\n\n    ( ) ?";
    ClientWidth = iWidth_;
    ClientHeight = iHeight_;
    // Check for full screen
    if(Application->MessageBox(str, "  - ",
                               MB_YESNO)==IDYES)   //|MB_ICONQUESTION
    { 
      // Switch screen resolution to the same as the form
      DEVMODE dmScreenSettings;								// Device Mode
		  memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		  dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		  dmScreenSettings.dmPelsWidth	= iWidth_;			    // Selected Screen Width
		  dmScreenSettings.dmPelsHeight	= iHeight_;				  // Selected Screen Height
		  dmScreenSettings.dmBitsPerPel	= iColor_;  	   	  // Selected Bits Per Pixel
		  dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

  		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
        if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
      //  if (ChangeDisplaySettings(NULL,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)

      		  {
        return false;
		  }
      else
      {
        BorderStyle = bsNone;
        Left = 0;
        Top = 0;
      }
    }
    else
    {
    ClientWidth = 640;
    ClientHeight = 480;
    }
    return true;

}
//---------------------------------------------------------------------------

bool __fastcall TMainForm::InitGL()
{
  wglMakeCurrent(m_hDC, m_hRC);
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);	// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
        glEnable(GL_TEXTURE_2D);
if(CubTexture) LoadGLTextures();
  wglMakeCurrent(m_hDC, NULL);
	return TRUE;										      // Initialization Went OK
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RenderGLScene()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	   // Clear Screen and Depth Buffer
	glLoadIdentity();								 // Reset The Current Modelview Matrix	glTranslatef(1.5f,0.0f,-6.0f);	 // Move Right 1.5 Units And Into The Screen 6.0

        glRotatef(Z_look, 0.0f, 0.0f, 0.0f);
        glTranslatef(0,0,-bH*1.5f);
        glRotatef(X_look, 1.0f, 0.0f, 0.0f);
        glRotatef(Y_look, 0.0f, 1.0f, 0.0f);
        glRotatef(Z_look, 0.0f, 0.0f, 0.0f);
        glRotatef(R_look, 0.0f, 0.0f, 1.0f);
        glTranslatef(-bW/2,-bH/2,0);

        BasketDraw(0, 0, 0, bH, bW);





for(int i=0; i<bW;i++)
    for(int j=0; j<bH;j++)
        {
        if(basket[i][j])
        CubDraw(i,bH-j, 0, cub_H);
        }

float d;
if(FlowMove) d = (float)Y/(float)sp;
else d = Y/sp;

for(int i = 0; i < 8; i++)
    for(int j = 0; j < 8; j++)
        {
        int I = X_fig + i;
        int J =  j - 8;
        //if(J < 0) continue;
        if(I >= bW) continue;
        if(real_figure[i][j])
             CubDraw(I, bH - (d + J - 1.0f), 0, cub_H);
        }
        glFlush() ;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CubDraw(float X, float Y, float Z, float H)
{

if(CubTexture) glBindTexture(GL_TEXTURE_2D, m_uiTexture[0]);

        glBegin (GL_QUADS);
	       /* glColor3f(0.5f,0.5f,1.0f);
                //glColor3f(0.1f, 0.1f, 0.1f);
	     	glTexCoord2f(0.0f, 0.0f);glVertex3f( X, Y, Z);
                glTexCoord2f(1.0f, 0.0f);glVertex3f( X+H, Y, Z);
                //glColor3f(0.0f,1.0f,0.0f);
		glTexCoord2f(1.0f, 1.0f);glVertex3f( X+H, Y+H, Z);
		glTexCoord2f(0.0f, 1.0f);glVertex3f( X, Y+H, Z);
                  */

                glColor3f(0.3f,0.4f,0.3f);
               	glVertex3f( X, Y, Z);
                glVertex3f( X+H, Y, Z);
                glColor3f(0.0f,1.0f,0.0f);
		glVertex3f( X+H, Y+H, Z);
		glVertex3f( X, Y+H, Z);


                glColor3f(0.0f, 0.0f, 0.0f);
		glVertex3f( X, Y, Z-H);
		glVertex3f( X+H, Y, Z-H);
                glColor3f(1.0f,0.5f,0.0f);
		glVertex3f( X+H, Y+H, Z-H);
		glVertex3f( X, Y+H, Z-H);

	   	//glColor3f(1.0f,0.0f,0.0f);
		glVertex3f( X, Y, Z);
		glVertex3f( X, Y, Z-H);
                glColor3f(1.0f,0.0f,0.0f);
		glVertex3f( X, Y+H, Z-H);
                glVertex3f( X, Y+H, Z);

                //glColor3f(1.0f,1.0f,0.0f);
		glVertex3f( X+H, Y, Z);
		glVertex3f( X+H, Y+H, Z);
                glColor3f(1.0f,1.0f,0.0f);
		glVertex3f( X+H, Y+H, Z-H);
                glVertex3f( X+H, Y, Z-H);

                //glColor3f(0.0f,0.0f,1.0f);
                glVertex3f( X, Y, Z);
		glVertex3f( X+H, Y, Z);
                glColor3f(0.0f,0.0f,1.0f);
                glVertex3f( X+H, Y, Z-H);
                glVertex3f( X, Y, Z-H);

		//glColor3f(1.0f,0.0f,1.0f);
		glVertex3f( X, Y+H, Z);
		glVertex3f( X+H, Y+H, Z);
		glColor3f(1.0f,0.0f,1.0f);
                glVertex3f( X+H, Y+H, Z-H);
		glVertex3f( X, Y+H, Z-H);     

	glEnd();


}
//---------------------------------------------------------------------------

void __fastcall TMainForm::BasketDraw(float X, float Y, float Z, float bH_, float bW_)
{
float delt = cub_H - 2.0f;// 
if(delt > -1.0f) delt = -1.0f;// 

for(int i=0; i<=bH_;i++)
        {
        CubDraw(delt,i,0,1);
        CubDraw(bW_,i,0,1);
        }
for(int i=0; i<=bW_;i++)
        {
        CubDraw(i-1,0,0,1);
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    if(BorderStyle == bsNone)
  		ChangeDisplaySettings(NULL,0);
    wglMakeCurrent(m_hRC, NULL);
    wglDeleteContext(m_hRC);
    ReleaseDC(Handle, m_hDC);
    
    DestroyWindowHandle();

}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
bool __fastcall TMainForm::LoadGLTextures()	 // Load Bitmaps And Convert To Textures
{  //  
	bool boStatus = false;
/*
	AUX_RGBImageRec *pTexImage = auxDIBImageLoad("1.bmp");

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if (pTexImage != NULL)
	{
		boStatus = true;

		glGenTextures(1, &m_uiTexture[0]);					// Create The Texture

		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, m_uiTexture[0]);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, pTexImage->sizeX, pTexImage->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, pTexImage->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

		if (pTexImage->data)      // If Texture Image Exists
			free(pTexImage->data);  // Free The Texture Image Memory

		free(pTexImage);          // Free The Image Structure
	}
     */
	return boStatus;                 // Return The Status

}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TMainForm::FigureGrowth(bool f_g[15][15])
{
//   fig_gr
for(int i=0; i<15;i++)
    for(int j=0; j<15;j++)
        {f_g[i][j] = false;}

int CX,CY,Num;//  
CX =  CY = 7;
Num = 0;

do{

if(!(f_g[CX][CY])){f_g[CX][CY] = true; Num++;}

switch(random(4))
    {
    case 0:CX++;break;
    case 1:CX--;break;
    case 2:CY++;break;
    case 3:CY--;break;
    }
if(!only_max_fig)
    if(!random(kub_num*2)){return;}

} while( Num < kub_num);

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ShowFigure()
{
NowPaint = true;

     wglMakeCurrent(m_hDC, m_hRC);
     RenderGLScene();
     glFlush();
     SwapBuffers(m_hDC);
     wglMakeCurrent(m_hDC, NULL);

NowPaint = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FigureRotation(rotate_mass rot)
{
bool k[15][15];
for(int i=0; i<15;i++)
    for(int j=0; j<15;j++)
        {
        if(rot){k[i][j] = fig_gr[j][14-i];}
        else{k[i][j] = fig_gr[14-j][i];}
        }

for(int i=0; i<15;i++)
    for(int j=0; j<15;j++)
        {fig_gr[i][j] = k[i][j];}

ToRealFigure(real_figure ,fig_gr );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ToRealFigure(bool r_f[8][8], bool f_g[15][15])
{
int dI,dJ;
dI = -1;//    
dJ = -1;//    
int bool_sum = 0;
while(!bool_sum)
    {
    dI++;
    for(int j=0; j<15;j++)
        {bool_sum += f_g[dI][j];}
    }

bool_sum = 0;
while(!bool_sum)
    {
    dJ++;
    for(int i=0; i<15;i++)
        {bool_sum += f_g[i][14-dJ];}
    }

for(int i=0; i<8; i++)
    for(int j=14; j>6; j--)
        {
        if(i+dI > 14 || j-dJ < 0) continue;
        r_f[i][j-7] = f_g[i+dI][j-dJ];
        }
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if(Key == VK_ESCAPE){Close();return;}
if(Key == VK_NUMPAD4) Y_look -=1.0f;
if(Key == VK_NUMPAD6) Y_look +=1.0f;
if(Key == VK_NUMPAD8) X_look -=1.0f;
if(Key == VK_NUMPAD2) X_look +=1.0f;
if(Key == VK_ADD) Z_look +=1.0f;
if(Key == VK_SUBTRACT) Z_look -=1.0f;
if(Key == VK_NUMPAD0) R_look +=1.0f;
if(Key == VK_DECIMAL) R_look -=1.0f;
if(Key == VK_NUMPAD7) {X_look -=1.0f;Y_look -=1.0f;}
if(Key == VK_NUMPAD9) {X_look -=1.0f;Y_look +=1.0f;}
if(Key == VK_NUMPAD1) {X_look +=1.0f;Y_look -=1.0f;}
if(Key == VK_NUMPAD3) {X_look +=1.0f;Y_look +=1.0f;}
if(Key == VK_NUMPAD5) {X_look =0.0f; Y_look = 0.0f;Z_look = 0.0f;R_look = 0.0f;}


if(NowPaint) return;

if(GameOver)//{NewGame();return;}/*
    if(Application->MessageBox("  -  ?",
    "", MB_YESNO) == IDYES)
        {NewGame(); return;}
    else {GamePause = true; return;}

if(Key == 'N' && Application->MessageBox("\t  ?","", MB_YESNO) == IDYES)
        NewGame();

if(Key == VK_LEFT) CheckMove(M_left);

if(Key == VK_RIGHT) CheckMove(M_right);

if(Key == VK_UP) CheckMove(rotate_cw);

if(Key == VK_DOWN) CheckMove(M_down);
if(Key == 'S')
    {
    GamePause = true;
    ChangeDisplaySettings(NULL,0);
    Visible = false;
    SettingForm->ShowModal();
    }

if(Key == 'P') GamePause = !GamePause;//  'P'
if(Key == 'M')
    {
    GamePause = true;
    ChangeDisplaySettings(NULL,0);
    Application->Minimize();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::WhenIdle(TObject *Sender, bool &Done)
{
if(GamePause)return;
if(GameOver)//{NewGame();return;}/*
    if(Application->MessageBox("  -  ?",
    "", MB_YESNO) == IDYES)
        {GamePause = true; NewGame(); return;}
    else {GamePause = true; return;}

Done = false;
if(new_fig)InitFigure();
new_fig = false;



CheckMove(M_drop);
//AddToImageMass();
ShowFigure();

Y++;
Y_fig = Y/sp;
Sleep(20);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::InitFigure()
{
X_fig = bW/2 - 2;
Y = sp;

CopyFigMass(fig_gr,fig_gr_next);
ToRealFigure(real_figure,fig_gr);

FigureGrowth(fig_gr_next);
//ToRealFigure(real_figure_next,fig_gr_next);

CheckMass();
}
//---------------------------------------------------------------------------
//          
void __fastcall TMainForm::AddToImageMass()
{
for(int i = 0; i < bW; i++)
    for(int j = 0; j < bH; j++)
        {
        basket_image[i][j] =  basket[i][j];
        }

for(int i = 0; i < 8; i++)
    for(int j = 0; j < 8; j++)
        {
        if(Y_fig + j - 8 < 0) continue;
        if(X_fig + i >= bW) continue;
        if(real_figure[i][j])
            basket_image[X_fig + i][Y_fig + j - 8] = real_figure[i][j];
        }
}
//---------------------------------------------------------------------------
//  
void __fastcall TMainForm::CheckMove(move_mass m)
{

bool it_is_imposible = false;
int k = sp - Y%sp;
// 
switch(m)
{
case M_left: X_fig--;break;
case M_right: X_fig++;break;
case rotate_cw: FigureRotation(clockwise); break;
case rotate_acw: FigureRotation(anticlockwise); break;
case M_down: Y += k;break;
case M_drop: Y ++;break;
}
Y_fig = Y/sp;
//     
if( X_fig < 0){X_fig = 0; return;}

for(int i = 0; i < 8; i++)
    for(int j = 0; j < 8; j++)
        {
        //     
        if(real_figure[i][j] && (X_fig + i) >= bW )
            {it_is_imposible = true; break;}


        if(Y_fig + j - 8 < 0) continue;
        if(X_fig + i >= bW) continue;
        //
        if(real_figure[i][j] && basket[X_fig + i][Y_fig + j - 8])
            {it_is_imposible = true; break;}
        }

if( Y_fig > bH){it_is_imposible = true;}
//     
if(it_is_imposible)
    switch(m)
    {
    case M_left: X_fig++;break;
    case M_right: X_fig--;break;
    case rotate_cw: FigureRotation(anticlockwise); break;
    case rotate_acw: FigureRotation(clockwise); break;
    case M_down: Y -= k;break;
    case M_drop: Y -=2; AddFigToMass();break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AddFigToMass()
{
Y_fig = Y/sp;
if(Y_fig < 2){GameOver = true;}
for(int i = 0; i < 8; i++)
    for(int j = 0; j < 8; j++)
        {
        if(Y_fig + j - 8 < 0) continue;
        if(X_fig + i >= bW) continue;
        if(real_figure[i][j])
        basket[X_fig + i][Y_fig + j - 8] = real_figure[i][j];
        }
new_fig = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckMass()
{
int sum;
for(int j = 0; j < bH; j++)
    {
    sum = 0;
    for(int i = 0; i<bW; i++)
       {
       if(basket[i][j])sum++;
       }
    if(sum == bW) DeleteLine(j);
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DeleteLine(int d_line)
{
for(int i = 0; i < bW; i++)
    for(int j = bH-1; j>=0; j--)
       {
       if(!j){basket[i][j] = false; continue;}
       if(j > d_line){ continue;}
       else{basket[i][j] = basket[i][j-1];}
       }

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CopyFigMass(bool f_g[15][15],bool f_g_next[15][15])
{
for(int i = 0; i < 15; i++)
    for(int j = 0; j < 15; j++)
        f_g[i][j] = f_g_next[i][j];


}
//---------------------------------------------------------------------------

void __fastcall TMainForm::NewGame()
{
//    
FigureGrowth(fig_gr_next);
//   
InitFigure();

for(int j = 0; j < bH; j++)
    for(int i = 0; i<bW; i++)
        basket[i][j] = false;
GamePause = false;
GameOver = false;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormPaint(TObject *Sender)
{
GamePause = false;
}
//---------------------------------------------------------------------------
